#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1  Aqua

//
//
//
//
//

extern string s01             = "--Ma Settings--";
extern int    MaPeriod        = 50;
extern int    MaShift         = 0;
extern int    MaMode          = MODE_EMA;
extern int    MaPrice         = PRICE_CLOSE;
extern string s02             = "--Price Settings--";
extern int    Price           = PRICE_CLOSE;

extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsNotify    = true;
extern bool   alertsEmail     = true;
extern string soundFile       = "alert2.wav"; 





double ma[];
double trend[];

//
//
//
//
//

int init()
{
   IndicatorBuffers(2);
   SetIndexBuffer(0,ma);  
   SetIndexBuffer(1,trend); 
return(0);
}

int deinit(){return(0);}

//
//
//
//
//

int start()
  {
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         
   //
   //
   //
   //
   //
         
   for (i=limit; i>=0; i--)
   {  
      double pr    = iMA(NULL,0,1,0,MODE_SMA,Price,i);   
             ma[i] = iMA(NULL,0,MaPeriod,MaShift,MaMode,MaPrice,i);
             trend[i] = trend[i+1];
               if(ma[i]<pr) trend[i] = 1;
               if(ma[i]>pr) trend[i] =-1;
   }
   
   //
   //
   //
   //
   //
   
   if (alertsOn)
   {
     if (alertsOnCurrent)
          int whichBar = 0;
     else     whichBar = 1;
     if (trend[whichBar] != trend[whichBar+1])
     if (trend[whichBar] == 1)
           doAlert("Buy");
     else  doAlert("Sell");       
   }
return(0);
}

//+------------------------------------------------------------------+
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," price cross ma ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(StringConcatenate(Symbol(), Period() ," price cross ma " +" "+message));
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," price cross ma "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}




